/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-07-18 10:38:43.
 * *************************************************
 */

package cn.com.qmth.examcloud.app.controller;

import cn.com.qmth.examcloud.app.model.Result;
import cn.com.qmth.examcloud.app.service.CoreOeService;
import cn.com.qmth.examcloud.app.service.SmsService;
import cn.com.qmth.examcloud.app.service.CoreAuthService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import static cn.com.qmth.examcloud.app.model.Constants.PARAM_APP_KEY;
import static cn.com.qmth.examcloud.app.model.Constants.PARAM_APP_TOKEN;

/**
 * 系统服务相关接口
 *
 * @version v1.0
 * @author: fengdesheng
 * @since: 2018/7/16
 */
@RestController
@RequestMapping("${$rmp}/v2")
@Api(tags = "系统服务相关接口")
public class SystemRestController {
    @Autowired
    private CoreOeService oeService;
    @Autowired
    private CoreAuthService authService;
    @Autowired
    private SmsService smsService;

    @ApiOperation(value = "获取服务器当前时间接口")
    @RequestMapping(value = "/system/currentTime", method = {RequestMethod.POST})
    public Result getCurrentTime(@RequestHeader(name = PARAM_APP_KEY) String key, @RequestHeader(name = PARAM_APP_TOKEN) String token) throws Exception {
        return oeService.getCurrentTime(key, token);
    }

    @ApiOperation(value = "获取短信验证码接口")
    @RequestMapping(value = "/send/sms/code", method = {RequestMethod.POST})
    public Result sendSmsCode(@RequestHeader(name = PARAM_APP_KEY) String key, @RequestHeader(name = PARAM_APP_TOKEN) String token, @RequestParam String phone) throws Exception {
        return authService.sendSmsCode(key, token, phone);
    }

    @ApiOperation(value = "获取短信验证码接口（不带token）")
    @RequestMapping(value = "/send/sms/code4Student", method = {RequestMethod.POST})
    public Result sendSmsCode(@RequestParam String phone) throws Exception {
        return authService.code4Student(phone, true);
    }

    @ApiOperation(value = "校验短信验证码接口", hidden = true)
    @RequestMapping(value = "/check/sms/code", method = {RequestMethod.POST})
    public Result checkSmsCode(@RequestHeader(name = PARAM_APP_KEY) String key, @RequestHeader(name = PARAM_APP_TOKEN) String token, @RequestParam String phone, @RequestParam String code) throws Exception {
        return smsService.checkSmsCode(key, token, phone, code);
    }

}